<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'user';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'user');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 会员模块
include_once (ROOT_PATH . 'include/user.class.php');
$dou_user = new DouUser();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/avatar/', null, 'jpg,gif,png'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center('user', 'admin'));

/**
 * +----------------------------------------------------------
 * 会员等级列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['user_level']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['user_level_add'],
            'href' => 'user_level.php?rec=add' 
    ));
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('user_level') . " ORDER BY level_id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $level_list[] = array (
                "level_id" => $row['level_id'],
                "name" => $row['name'],
                "upgrade_type" => $row['upgrade_type'],
                "upgrade_condition" => $row['upgrade_condition'],
                "good_discount" => $row['good_discount'],
                "direct_reward" => $row['direct_reward'],
                "indirect_reward" => $row['indirect_reward'],
                "icon" => $dou->dou_file($row['icon']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('level_list', $level_list);
    
    $smarty->display('user_level.htm');
}

/**
 * +----------------------------------------------------------
 * 会员等级添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['user_level_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['user_level_list'],
            'href' => 'user_level.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
 
    // 初始值
    $user_level['good_discount'] = 100;
    $user_level['upgrade_condition'] = $user_level['direct_reward'] = $user_level['indirect_reward'] = 0;
    
    // 赋值给模板
    $smarty->assign('user_level', $user_level);
    $smarty->assign('form_action', 'insert');
    
    $smarty->display('user_level.htm');
} 

elseif ($rec == 'insert') {
    // 判断是否为空
    $wrong = $check->fn_empty('user_level', 'name, upgrade_condition, good_discount, direct_reward, indirect_reward');

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['article']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 文件上传盒子
    $icon = $file->box('user_level', $dou->auto_id('user_level'), 'icon', 'main');
 
    // 格式化数据
    $add_time = time();
 
    $sql = "INSERT INTO " . $dou->table('user_level') . " (level_id, name, upgrade_type, upgrade_condition, good_discount, direct_reward, indirect_reward, icon, add_time)" . " VALUES (NULL, '$_POST[name]', '$_POST[upgrade_type]', '$_POST[upgrade_condition]', $_POST[good_discount], '$_POST[direct_reward]', '$_POST[indirect_reward]', '$icon', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['user_level_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['user_level_add'] . $_LANG['success'], 'user_level.php');
} 

/**
 * +----------------------------------------------------------
 * 会员等级编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['user_level_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['user_level_list'],
            'href' => 'user_level.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());

    // 验证并获取合法的ID
    $level_id = $check->is_number($_REQUEST['level_id']) ? $_REQUEST['level_id'] : '';
    
    $user_level = $dou->get_row('user_level', '*', "level_id = '$level_id'");
    $user_level['icon'] = $user_level['icon'] ? $dou->dou_file($user_level['icon']) : '';
    
    // 赋值给模板
    $smarty->assign('user_level', $user_level);
    $smarty->assign('form_action', 'update');
    
    $smarty->display('user_level.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $level_id = $check->is_number($_POST['level_id']) ? $_POST['level_id'] : '';
    
    // 判断是否为空
    $wrong = $check->fn_empty('user_level', 'name, upgrade_condition, good_discount, direct_reward, indirect_reward');

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['article']);
    }
 
    // 文件上传盒子
    $icon = $file->box('user_level', $level_id, 'icon', 'main');
    $icon = $icon ? ", icon = '" . $icon . "'" : '';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('user_level') . " SET name = '$_POST[name]', upgrade_type = '$_POST[upgrade_type]', upgrade_condition = '$_POST[upgrade_condition]', good_discount = '$_POST[good_discount]', direct_reward = '$_POST[direct_reward]', indirect_reward = '$_POST[indirect_reward]'" . $icon . " WHERE level_id = '$level_id'";
    $dou->query($sql);
 
    $dou->create_admin_log($_LANG['user_level_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['user_level_edit'] . $_LANG['success'], 'user_level.php');
}

/**
 * +----------------------------------------------------------
 * 会员等级删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $level_id = $check->is_number($_POST['level_id']) ? $_POST['level_id'] : $dou->dou_msg($_LANG['illegal'], 'user_level.php');
    $name = $dou->get_value('user', 'name', "level_id = '$level_id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['user_level_del'] . ': ' . $name);
        $dou->delete('user_level', "level_id = $level_id", 'user_level.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'user_level.php', '', '30', "user_level.php?rec=del&level_id=$level_id");
    }
}

?>