// pages/book/book.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    contact_list: []
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
    
    that.loadData()
  },
 
  onLoad: function(options) {
    var that = this
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site,
          open: res.data.open,
          title: res.data.lang.user_contact_manager
        })
       
        // 设置转发标题缓存
        wx.setStorageSync('shareTitle', res.data.lang.user_contact_manager)
    
        // 显示转发按钮
        dou.showShareMenu()
      },
    })
  },

  // 获取数据
  loadData: function() {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'user.php?rec=contact',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell')
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          contact_list: res.data.contact_list
        })
      }
    })
  },
 
  // 设为默认
  setDefault(e) {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=set',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: e.currentTarget.dataset.id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.loadData()
      }
    })
  },
 
  // 设为默认
  del(e) {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=del',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: e.currentTarget.dataset.id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.loadData()
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})