<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'login|login_post|register|register_post|edit|edit_post|password|password_post|verification|verification_post|password_reset|password_reset_post|telphone|telphone_post|email|email_post|logout|order_list|order|order_cancel|sns|sns_link|contact|filebox|filedel|promotion_qrcode';
$subbox = array(
        "module" => 'user',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'user';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
if (isset($_REQUEST['rec'])) {
    $rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : $dou->dou_msg('page_wrong', HOME_URL);
} else {
    $rec = 'default';
}

// 引入和实例化订单功能
if (file_exists($order_file = ROOT_PATH . 'include/order.class.php')) {
    include_once ($order_file);
    $dou_order = new Order();
}

// 设定不需要登录权限和不需要验证的页面
$no_login_array = explode('|', 'login|login_post|register|register_post|password_reset|password_reset_post|sns_link');
$no_check_array = explode('|', 'verification|verification_post');

// 需要登录且没有登录的情况
if (!in_array($rec, $no_login_array) && !is_array($_GLOBAL_USER) && !in_array($rec, $no_check_array)) {
    $dou->dou_header($_URL['login']);
} else {
    $user_id = $_GLOBAL_USER['user_id'];
}

// 不需要登录却登录的情况
if (in_array($rec, $no_login_array) && is_array($_GLOBAL_USER) && !in_array($rec, $no_check_array))
    $dou->dou_header($_URL['user']);

// 实例化售后功能
if (file_exists($aftersale_file = ROOT_PATH . 'include/aftersale.class.php')) {
    include_once ($aftersale_file);
    $dou_aftersale = new Aftersale();
}

// 实例化评论功能
if (file_exists($comment_file = ROOT_PATH . 'include/comment.class.php')) {
    include_once ($comment_file);
    $dou_comment = new Comment();
}

// 实例化验证码
require (ROOT_PATH . 'include/captcha.class.php');
$captcha = new Captcha();

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'user', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center());
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));

/**
 * +----------------------------------------------------------
 * 会员中心
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 获取会员信息
    $user_info = $dou->get_row('user', '*', "user_id = '$user_id'");
 
    // 格式化数据
    $user_info['avatar'] = $user_info['avatar'] ? $dou->dou_file($user_info['avatar']) : ROOT_URL . 'images/avatar/..empty.png';
    $user_info['last_login'] = date("Y-m-d H:i", $dou->get_first_log($user_info['last_login']));
    $user_info['last_ip'] = $dou->get_first_log($user_info['last_ip']);
    $user_info['point'] = $dou_user->point($user_info['user_id']);
    $user_info['promotion_link'] = $dou->param($_URL['register'] . '&user_sn=' . $user_info['user_sn']);

    $smarty->assign('page_title', $dou->page_title('user'));
    $smarty->assign('ur_here', $dou->ur_here('user'));
    $smarty->assign('head', $_LANG['user']);
    $smarty->assign('user_info', $user_info);
    $smarty->assign('welcome', $dou_user->welcome());
    $smarty->display('user.dwt');
}

/**
 * +----------------------------------------------------------
 * 登录注册页面
 * +----------------------------------------------------------
 */
elseif ($rec == 'register') {
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('user_register'));
    
    // 验证码令牌
    $smarty->assign("captcha_token", $captcha->token_set());
 
    // 用户协议
    if (!$dou->value_exist('page', 'unique_id', 'agreement')) {
        $dou->query("INSERT INTO " . $dou->table('page') . " (id, unique_id, page_name)" . " VALUES (NULL, 'agreement', '用户协议')");
        $dou->dou_header($_URL['register']);
    }
 
    // 推广注册
    $user_sn = $check->is_number($_REQUEST['user_sn']) ? trim($_REQUEST['user_sn']) : '';
    if ($user_sn)
        $_SESSION[DOU_ID]['promotion_user_sn'] = $user_sn;
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_register'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_register'));
    $smarty->assign('head', $_LANG['user_register']);
    $smarty->assign('sns_token', $check->is_number($_REQUEST['sns_token']) ? trim($_REQUEST['sns_token']) : '');
    
    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 注册提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'register_post') {
    // 验证用户名
    if ($_POST['email']) { // 邮箱注册
        if (!$check->is_email($_POST['email'])) {
            $wrong['email'] = $_LANG['user_email_cue'];
        } elseif ($dou->value_exist('user', 'email', $_POST['email'])) {
            $wrong['email'] = $_LANG['user_email_exist'];
        }
        $field = 'email';
     
        // 如果有设置邮件服务器账号，启用验证码
        if ($_CFG['mail_username'])
            $check_verification = true;
    } else { // 手机号注册
        if (!$check->is_telphone($_POST['telphone'])) {
            $wrong['telphone'] = $_LANG['user_telphone_cue'];
        } elseif ($dou->value_exist('user', 'telphone', $_POST['telphone'])) {
            $wrong['telphone'] = $_LANG['user_telphone_exist'];
        }
        $field = 'telphone';
     
        // 如果有开启短信服务，启用验证码
        if ($_PARAM['sms_accessKeyId'])
            $check_verification = true;
    }
 
    // 判断验证码
    if ($check_verification) {
        if (md5($_POST['verification'] . DOU_SHELL) != $_SESSION[DOU_ID]['verification']['code'] || $_POST[$field] != $_SESSION[DOU_ID]['verification']['account']) {
            $wrong['verification'] = $_LANG['verification_wrong'];
        } elseif (!$captcha->ontime()) { // 判断验证码是否超时
            $wrong['verification'] = $_LANG['verification_outtime'];
        }
    }
    
    // 验证密码
    if (!$check->is_password($_POST['password']))
        $wrong['password'] = $_LANG['user_password_cue'];
    
    // 验证确认密码
    if (!isset($wrong['password']) && ($_POST['password_confirm'] !== $_POST['password']))
        $wrong['password_confirm'] = $_LANG['user_password_confirm_cue'];
    
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['user']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'user_register');
    
    // 格式化数据
    $user_sn = $dou_user->rand_user_sn();
    $password = md5($_POST['password']);
    $add_time = time();
    $phone = $_POST['telphone'];
 
    // 推广注册
    if ($_SESSION[DOU_ID]['promotion_user_sn']) {
        $direct_user_id = $dou->get_value('user', 'user_id', "user_sn = '" . $_SESSION[DOU_ID]['promotion_user_sn'] . "'");
        $indirect_user_id = $dou->get_value('user', 'direct_user_id', "user_id = '$direct_user_id'");
    } else {
        $direct_user_id = $indirect_user_id = 0;
    }
    
    if ($_POST['email']) {
        $sql = "INSERT INTO " . $dou->table('user') . " (user_id, user_sn, direct_user_id, indirect_user_id, email, telphone, password, phone, add_time)" . " VALUES (NULL, '$user_sn', '$direct_user_id', '$indirect_user_id', '$_POST[email]', NULL, '$password', '$phone', '$add_time')";
    } else {
        $sql = "INSERT INTO " . $dou->table('user') . " (user_id, user_sn, direct_user_id, indirect_user_id, email, telphone, password, phone, add_time)" . " VALUES (NULL, '$user_sn', '$direct_user_id', '$indirect_user_id', NULL, '$_POST[telphone]', '$password', '$phone', '$add_time')";
    }
    
    $dou->query($sql);
        
    // 注册成功后直接登录
    $user = $dou->get_row('user', '*', "$field = '$_POST[$field]'");
    
    // 判断是否正在操作SNS绑定
    $sns_token = $check->is_number($_REQUEST['sns_token']) ? trim($_REQUEST['sns_token']) : '';
    if (is_array($sns = $_SESSION[DOU_ID]['sns'][$sns_token])) {
        $dou->query("INSERT INTO " . $dou->table('user_sns') . " (id, user_id, `group`, openid, unionid, apptype, add_time)" . " VALUES (NULL, '$user[user_id]', '$sns[group]', '$sns[openid]', '$sns[unionid]', '$sns[apptype]', '$add_time')");
        $dou->query("UPDATE " . $dou->table('user') . " SET nickname = '$sns[nickname]', avatar = '$sns[avatar]', sex = '$sns[sex]' WHERE user_id = '$user[user_id]'");
    }
    
    // 写入登录凭证和登录记录
    $dou_user->login($user, $field);

    $dou->dou_msg($_LANG['user_insert_success'], $_URL['user']);
}

/**
 * +----------------------------------------------------------
 * 登录页
 * +----------------------------------------------------------
 */
elseif ($rec == 'login') {
    // SNS登录
    $sns = $check->is_rec($_REQUEST['sns']) ? $_REQUEST['sns'] : '';
    if ($sns)
        $dou->dou_header(HOME_URL . 'include/plugin/' . $sns . '/login.php');
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('user_login'));
    
    $return_url = $_REQUEST['return_url'] ? $_REQUEST['return_url'] : ($_SERVER['HTTP_REFERER'] ? urlencode($_SERVER['HTTP_REFERER']) : HOME_URL);
    
    // 赋值给模板息
    $smarty->assign('page_title', $dou->page_title('user', 'user_login'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_login'));
    $smarty->assign('head', $_LANG['user_login']);
    $smarty->assign('return_url', $return_url);
    $smarty->assign('sns_token', $check->is_number($_REQUEST['sns_token']) ? trim($_REQUEST['sns_token']) : '');
    $smarty->assign('connect_plugin_list', $dou_user->connect_plugin_list());
    
    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 登录提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'login_post') {
    // 验证用户名
    if (!$_POST['username']) {
        $wrong['username'] = $_LANG['user_username_cue'];
    } elseif ($check->is_email($_POST['username'])) {
        $field = 'email';
    } elseif ($check->is_telphone($_POST['username'])) {
        $field = 'telphone';
    } else {
        $wrong['username'] = $_LANG['user_username_cue'];
    }

    $_POST['password'] = $check->is_password(trim($_POST['password'])) ? trim($_POST['password']) : '';
    
    // 如果用户名存在则获取用户信息
    $user = $dou->get_row('user', '*', "$field = '$_POST[username]'");
    
    // 验证用户是否存在和密码是否正确
    if (!is_array($user)) {
        $wrong['password'] = $_LANG['user_login_wrong'];
    } elseif (md5($_POST['password']) != $user['password']) {
        $wrong['password'] = $_LANG['user_login_wrong'];
    }
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['user']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'user_login');
    
    // 判断是否正在操作SNS绑定
    $sns_token = $check->is_number($_REQUEST['sns_token']) ? trim($_REQUEST['sns_token']) : '';
    if (is_array($sns = $_SESSION[DOU_ID]['sns'][$sns_token])) {
        $add_time = time();
        $dou->query("INSERT INTO " . $dou->table('user_sns') . " (id, user_id, `group`, openid, unionid, apptype, add_time)" . " VALUES (NULL, '$user[user_id]', '$sns[group]', '$sns[openid]', '$sns[unionid]', '$sns[apptype]', '$add_time')");
    }
    
    // 写入登录凭证和登录记录
    $dou_user->login($user, $field);
    
    if ($_OPEN['work']) {
        if ($dou->value_exist('work', 'user_id', $user['user_id'])) {
            $dou->dou_header($_URL['work']);
        }
    }
    
    $dou->dou_header(urldecode($_POST['return_url']));
}

/**
 * +----------------------------------------------------------
 * 会员信息编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 获取会员信息
    $user_info = $dou->get_row('user', '*', "user_id = '$user_id'");
 
    // 格式化数据
    $user_info['avatar'] = $user_info['avatar'] ? $dou->dou_file($user_info['avatar']) : ROOT_URL . 'images/avatar/..empty.png';
    $user_info['phone'] = !$user_info['phone'] ? $user_info['telphone'] : $user_info['phone'];

    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token('static_user'));
    
    // 格式化自定义参数
    if ($_DEFINED['user'] || $user_info['defined']) {
        $defined = explode(',', $_DEFINED['user']);
        foreach ($defined as $row) {
            $defined_user .= $row . "：\n";
        }
        // 如果商品中已经写入自定义参数则调用已有的
        $user_info['defined'] = $user_info['defined'] ? str_replace(",", "\n", $user_info['defined']) : trim($defined_user);
        $user_info['defined_count'] = count(explode("\n", $user_info['defined'])) * 2;
    }

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_edit'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_edit'));
    $smarty->assign('head', $_LANG['user_edit']);
    $smarty->assign('user_info', $user_info);

    $smarty->display('user.dwt');
}

/**
 * +----------------------------------------------------------
 * 会员信息编辑提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit_post') {
    // 获取已有会员信息
    $user = $dou->get_row('user', '*', "user_id = '$_GLOBAL_USER[user_id]'");
 
    // 判断是否为空
    $wrong = $check->fn_empty('user', 'nickname, contact, phone');
 
    // 判断是否含有非法字符
    $wrong = $check->fn_illegal_char('user', 'contact, first_name, last_name, phone, country, province, address, postcode, nickname');
 
    // 验证昵称
    if ($_POST['nickname']) {
        if ($user['nickname'] != $_POST['nickname']) {
            if ($dou->value_exist('user', 'nickname', $_POST['nickname']))
                $wrong['nickname'] = $_LANG['user_nickname'] . $_LANG['value_exists'];
        }
    }

    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }
 
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/avatar/', null, 'jpg,jpeg,gif,png'); // 实例化类文件(文件上传路径，结尾加斜杠)
 
    // 文件上传盒子
    if ($_FILES['avatar']['name'] != "") {
        if ($dou->get_value('user', 'avatar', "user_id = '$_GLOBAL_USER[user_id]'"))
            $avatar_filename = $dou_user->create_avatar_filename();
        
        $avatar = $file->box('user', $_GLOBAL_USER['user_id'], 'avatar', 'main', $avatar_filename, '', '', 200, '', 'user_id');
        $avatar = ", avatar = '" . $avatar . "'";
    }
    
    // 格式化自定义参数
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'static_user');
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
 
    // 判断是中文还是英文联系人信息
    $field_sql = $_CFG['language'] == 'en_us' ? ", first_name = '$_POST[first_name]', last_name = '$_POST[last_name]', country = '$_POST[country]', province = '$_POST[province]'" : ", contact = '$_POST[contact]'";
    
    $sql = "UPDATE " . $dou->table('user') . " SET phone = '$_POST[phone]'" . $field_sql . ", address = '$_POST[address]', postcode = '$_POST[postcode]', sex = '$_POST[sex]', nickname = '$_POST[nickname]'" . $avatar . ", defined = '$_POST[defined]' WHERE user_id = '$_GLOBAL_USER[user_id]'";
    
    $dou->query($sql);
    
    $dou->dou_msg($_LANG['user_edit_success'], $_URL['edit']);
}

/**
 * +----------------------------------------------------------
 * 密码修改
 * +----------------------------------------------------------
 */
elseif ($rec == 'password') {
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token('static_user'));

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_password_edit'));
    $smarty->assign('head', $_LANG['user_password_edit']);
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_password_edit'));

    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 密码修改提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'password_post') {
    // 获取旧密码
    $old_password = $dou->get_one("SELECT password FROM " . $dou->table('user') . " WHERE user_id = '$_GLOBAL_USER[user_id]'");

    // 验证原始密码密码
    if (md5($_POST['old_password']) != $old_password)
        $wrong['old_password'] = $_LANG['user_old_password_cue'];

    // 验证密码
    if (!$check->is_password($_POST['password']))
        $wrong['password'] = $_LANG['user_password_cue'];
    
    // 验证确认密码
    if ($_POST['password_confirm'] !== $_POST['password'])
        $wrong['password_confirm'] = $_LANG['user_password_confirm_cue'];
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['user']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'static_user');
    
    $sql = "UPDATE " . $dou->table('user') . " SET password = '" . md5($_POST['password']) . "' WHERE user_id = '$_GLOBAL_USER[user_id]'";
    $dou->query($sql);
    
    $dou->dou_msg($_LANG['user_password_success'], $_URL['edit']);
}

/**
 * +----------------------------------------------------------
 * 验证码
 * +----------------------------------------------------------
 */
elseif ($rec == 'verification') {
    $type = $check->is_rec($_REQUEST['type']) ? $_REQUEST['type'] : 'sms';
    $check_account = $_GLOBAL_USER['account'] ? $_GLOBAL_USER['account'] : $_SESSION[DOU_ID]['action_account'];
    
    if (!isset($_SESSION[DOU_ID]['verification_next_url']) || !$check_account) {
        $dou->dou_header(ROOT_URL);
    } else {
        $user_info = $dou->get_row('user', '*', "email = '$check_account' OR telphone = '$check_account'");
        $field = $type == 'sms' ? 'telphone' : 'email';
        $_SESSION[DOU_ID]['check_account'] = $user_info[$field];
        unset($_SESSION[DOU_ID]['verid']);
    }
    
    $ver['value'] = $type;
    $ver['sms'] = $dou->param($_URL['verification'] . '&type=sms');
    $ver['email'] = $dou->param($_URL['verification'] . '&type=email');
 
    if ($type == 'sms' && !$user_info['telphone'])
        $dou->dou_header($ver['email']);

    $smarty->assign('verification_check_cue', preg_replace('/d%/Ums', $check_account, $_LANG['verification_check_cue']));
    $smarty->assign("captcha_token", $captcha->token_set()); // 短信验证码令牌
    $smarty->assign('ver', $ver);
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_verification'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_verification'));
    $smarty->assign('act', $act);
    $smarty->assign('user_info', $user_info);

    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 验证码提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'verification_post') {
    $type = $check->is_rec($_REQUEST['type']) ? $_REQUEST['type'] : 'sms';
    
    $check_account = $_SESSION[DOU_ID]['check_account'];
 
    if (!isset($_SESSION[DOU_ID]['verification_next_url']) || !$check_account)
        $dou->dou_header(ROOT_URL);
    
    // 判断验证码
    if (md5($_POST['verification'] . DOU_SHELL) != $_SESSION[DOU_ID]['verification']['code'] || $check_account != $_SESSION[DOU_ID]['verification']['account']) {
        $dou->dou_msg($_LANG['verification_wrong'], $dou->param($_URL['verification'] . '&type=' . $type));
    } elseif (!$captcha->ontime()) { // 判断验证码是否超时
        $dou->dou_msg($_LANG['verification_outtime'], $dou->param($_URL['verification'] . '&type=' . $type));
    } else {
        $dou->dou_header($_SESSION[DOU_ID]['verification_next_url']);
    }
}

/**
 * +----------------------------------------------------------
 * 重置密码
 * +----------------------------------------------------------
 */
elseif ($rec == 'password_reset') {
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
 
    if ($act == 'default') {
        // CSRF防御令牌生成
        $smarty->assign('token', $firewall->set_token('user_password_reset'));
    } elseif ($act == 'password') {
        $check_account = $_SESSION[DOU_ID]['check_account'];
        
        if ($check_account != $_SESSION[DOU_ID]['verification']['account']) {
            $dou->dou_msg($_LANG['verification_wrong'], $_URL['password_reset']);
        } elseif (!$captcha->ontime()) { // 判断验证码是否超时
            $dou->dou_msg($_LANG['verification_outtime'], $_URL['password_reset']);
        }
        
        $smarty->assign('user_password_reset_check_cue', preg_replace('/d%/Ums', $check_account, $_LANG['user_password_reset_check_cue']));
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_password_reset'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_password_reset'));
    $smarty->assign('act', $act);
    $smarty->assign('user_info', $dou->get_row('user', '*', "email = '$check_account' OR telphone = '$check_account'"));

    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 重置密码提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'password_reset_post') {
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
    
    if ($act == 'default') {
        // 验证用户名
        if (!$_POST['username']) {
            $dou->dou_msg($_LANG['user_username'] . $_LANG['is_empty'], $_URL['password_reset']);
        } else {
            if ($check->is_email($_POST['username'])) {
                if (!$dou->value_exist('user', 'email', $_POST['username']))
                    $dou->dou_msg($_LANG['user_password_reset_email_no_exist'], $_URL['password_reset']);
            } else {
                if (!$dou->value_exist('user', 'telphone', $_POST['username']))
                    $dou->dou_msg($_LANG['user_password_reset_telphone_no_exist'], $_URL['password_reset']);
            }
        }
    
        // 判断验证码
        $captcha = $check->is_captcha($_POST['captcha']) ? strtoupper($_POST['captcha']) : '';
        if ($_CFG['captcha'] && md5($captcha . DOU_SHELL) != $_SESSION['captcha'])
            $dou->dou_msg($_LANG['captcha_wrong'], $_URL['password_reset']);
        
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token'], 'user_password_reset');
        
        // 生成缓存
        $_SESSION[DOU_ID]['action_account'] = $_POST['username'];
        $_SESSION[DOU_ID]['verification_next_url'] = $dou->param($_URL['password_reset'] . '&act=password');
        
        $dou->dou_header($_URL['verification']);
    } elseif ($act == 'password') {
        // 上一步的身份验证再次核实
        $check_account = $_SESSION[DOU_ID]['check_account'];
        if ($check_account != $_SESSION[DOU_ID]['verification']['account']) {
            $dou->dou_msg($_LANG['verification_wrong'], $_URL['password_reset']);
        } elseif (!$captcha->ontime()) { // 判断验证码是否超时
            $dou->dou_msg($_LANG['verification_outtime'], $_URL['password_reset']);
        }
        
        // 验证密码
        if (!$check->is_password($_POST['password'])) {
            $dou->dou_msg($_LANG['user_password_cue']);
        } elseif (($_POST['password_confirm'] !== $_POST['password'])) {
            $dou->dou_msg($_LANG['user_password_confirm_cue']);
        }
        
        $action_time = time();
            
        // 重置密码
        $sql = "UPDATE " . $dou->table('user') . " SET password = '" . md5($_POST['password']) . "', action_time = '$action_time' WHERE email = '$check_account' OR telphone = '$check_account'";
        $dou->query($sql);
        $dou->dou_msg($_LANG['user_password_reset_success'], $_URL['login'], 15);
    }
}

/**
 * +----------------------------------------------------------
 * 手机号修改设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'telphone') {
    // 生成缓存
    $_SESSION[DOU_ID]['verification_next_url'] = $dou->param($_URL['telphone']);
    
    // 上一步的身份验证再次核实
    $check_account = $_SESSION[DOU_ID]['check_account'];
    if ($check_account != $_SESSION[DOU_ID]['verification']['account'] || !$captcha->ontime()) {
        $dou->dou_header($_URL['verification']);
    } else {
        $_SESSION[DOU_ID]['verid'] = 'ver_telphone';
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_modify_telphone'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_modify_telphone'));
    $smarty->assign('act', $act);
    $smarty->assign("captcha_token", $captcha->token_set()); // 短信验证码令牌

    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 手机号修改设置 提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'telphone_post') {
    // 生成缓存
    $_SESSION[DOU_ID]['verification_next_url'] = $dou->param($_URL['telphone']);
    
    // 上一步的身份验证再次核实
    $check_account = $_SESSION[DOU_ID]['check_account'];
    if ($check_account != $_SESSION[DOU_ID]['verification']['account']) {
        $dou->dou_header($_URL['verification']);
    } elseif (!$captcha->ontime()) { // 判断验证码是否超时
        $dou->dou_msg($_LANG['verification_outtime'], $_URL['verification']);
    }
 
    // 验证新修改的手机号是否正确且未被占用
    if (!$check->is_telphone($_POST['telphone'])) {
        $dou->dou_msg($_LANG['user_telphone_cue']);
    }
 
    // 验证新手机号的短信验证码
    if (md5($_POST['verification'] . DOU_SHELL) != $_SESSION[DOU_ID]['ver_telphone']['code'] || $_POST['telphone'] != $_SESSION[DOU_ID]['ver_telphone']['account']) {
        $dou->dou_msg($_LANG['verification_wrong']);
    } elseif (!$captcha->ontime('ver_telphone')) { // 判断验证码是否超时
        $dou->dou_msg($_LANG['verification_outtime']);
    } else {
        $dou->query("UPDATE " . $dou->table('user') . " SET telphone = '" . $_POST['telphone'] . "' WHERE user_id = '$_GLOBAL_USER[user_id]'");
        unset($_SESSION[DOU_ID]);
        $dou->dou_header($_URL['login']);
    }
}

/**
 * +----------------------------------------------------------
 * 邮箱修改设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'email') {
    // 生成缓存
    $_SESSION[DOU_ID]['verification_next_url'] = $dou->param($_URL['email']);
    
    // 上一步的身份验证再次核实
    $check_account = $_SESSION[DOU_ID]['check_account'];
    if ($check_account != $_SESSION[DOU_ID]['verification']['account'] || !$captcha->ontime()) {
        $dou->dou_header($_URL['verification']);
    } else {
        $_SESSION[DOU_ID]['verid'] = 'ver_email';
    }
    
    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'user_modify_email'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_modify_email'));
    $smarty->assign('act', $act);
    $smarty->assign("captcha_token", $captcha->token_set()); // 短信验证码令牌

    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 邮箱修改设置 提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'email_post') {
    // 生成缓存
    $_SESSION[DOU_ID]['verification_next_url'] = $dou->param($_URL['email']);
    
    // 上一步的身份验证再次核实
    $check_account = $_SESSION[DOU_ID]['check_account'];
    if ($check_account != $_SESSION[DOU_ID]['verification']['account']) {
        $dou->dou_header($_URL['verification']);
    } elseif (!$captcha->ontime()) { // 判断验证码是否超时
        $dou->dou_msg($_LANG['verification_outtime'], $_URL['verification']);
    }
 
    // 验证新修改的手机号
    if (!$check->is_email($_POST['email'])) {
        $dou->dou_msg($_LANG['user_email_cue']);
    }
 
    // 验证新手机号的短信验证码
    if (md5($_POST['verification'] . DOU_SHELL) != $_SESSION[DOU_ID]['ver_email']['code'] || $_POST['email'] != $_SESSION[DOU_ID]['ver_email']['account']) {
        $dou->dou_msg($_LANG['verification_wrong']);
    } elseif (!$captcha->ontime('ver_email')) { // 判断验证码是否超时
        $dou->dou_msg($_LANG['verification_outtime']);
    } else {
        $dou->query("UPDATE " . $dou->table('user') . " SET email = '" . $_POST['email'] . "' WHERE user_id = '$_GLOBAL_USER[user_id]'");
        unset($_SESSION[DOU_ID]);
        $dou->dou_header($_URL['login']);
    }
}

/**
 * +----------------------------------------------------------
 * 退出登录
 * +----------------------------------------------------------
 */
elseif ($rec == 'logout') {
    unset($_SESSION[DOU_ID]);
    $dou->dou_header(HOME_URL);
}

/**
 * +----------------------------------------------------------
 * 我的订单
 * +----------------------------------------------------------
 */
elseif ($rec == 'order_list') {
    // 订单状态实时更新
    $dou_order->auto_cancel_order("user_id = '$_GLOBAL_USER[user_id]'"); // 订单超过时间未付款，将自动取消，并释放库存
    $dou_order->auto_update_aftersale_status("user_id = '$_GLOBAL_USER[user_id]'"); // 已发货订单列表需要实时更新订单可否申请状态
    $dou_order->auto_update_comment("user_id = '$_GLOBAL_USER[user_id]'"); // 已发货订单列表需要实时更新订单可评论状态，超时自动评价
    
    // 公用SQL查询条件，分页中也使用
    $where = " WHERE user_id = '$_GLOBAL_USER[user_id]'";
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('order') . $where . " ORDER BY order_id DESC";

    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['order_list']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $email = $dou->get_one("SELECT email FROM " . $dou->table('user') . " WHERE user_id = '$row[user_id]'");
        $add_time = date("Y-m-d H:i:s", $row['add_time']);
        $status_format = $_LANG['order_status_' . $row['status']];
        $order_amount_format = $dou->price_format($row['order_amount']);
        
        // 有开启支付方式的情况才显示付款按钮
        if ($dou->value_exist('plugin', 'plugin_group', 'payment'))
            $cashier_url = $dou->param($dou->rewrite_url('order', 'cashier') . '&order_sn=' . $row['order_sn']);
     
        // 判断是否有安装售后服务模块
        if ($_OPEN['aftersale'])
            $if_can_aftersale = $dou_aftersale->if_can_aftersale($row['order_id'], $_GLOBAL_USER['user_id']);

        $order_list[] = array (
                "order_id" => $row['order_id'],
                "order_sn" => $row['order_sn'],
                "order_link" => $dou->param($_URL['order'] . '&order_sn=' . $row['order_sn']),
                "email" => $email,
                "mode" => $row['mode'],
                "contact" => $row['contact'],
                "phone" => $row['phone'],
                "order_amount" => $row['order_amount'],
                "order_amount_format" => $order_amount_format,
                "order_point" => $row['order_point'],
                "order_point_format" => $row['order_point'] . $_LANG['point_point'],
                "status" => $row['status'],
                "status_format" => $row['aftersale_status'] == 2 ? $_LANG['order_aftersale_status_2'] : $status_format,
                "cashier_url" => $cashier_url,
                "if_can_aftersale" => $if_can_aftersale,
                "aftersale_url" => $dou->param($dou->rewrite_url('aftersale', 'apply') . '&order_sn=' . $row['order_sn']),
                "pay_time_limit" => $dou_order->pay_time_limit($row['add_time'], true), // 付款超时时间
                "add_time" => $add_time,
                "item_list" => $dou_order->get_order_item($row['order_id'])
        );
    }

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'order_my'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'order_my'));
    $smarty->assign('head', $_LANG['order_my']);
    $smarty->assign('order_list', $order_list);

    $smarty->display('user.dwt');
}

/**
 * +----------------------------------------------------------
 * 订单详情
 * +----------------------------------------------------------
 */
elseif ($rec == 'order') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'");
    
    // 判断订单是否存在
    if (!$order) $dou->dou_header($_URL['order_list']);
    
    // 订单状态实时更新
    if ($order['status'] == '0') { // 订单超过时间未付款，将自动取消，并释放库存
        $dou_order->auto_cancel_order("user_id = '$_GLOBAL_USER[user_id]' AND order_id = '$order[order_id]'");
    } else if ($order['status'] == '10') { // 已取货订单列表需要实时更新订单可否申请状态
        $dou_order->auto_update_aftersale_status("user_id = '$_GLOBAL_USER[user_id]' AND order_id = '$order[order_id]'");
        $dou_order->auto_update_comment("user_id = '$_GLOBAL_USER[user_id]'");
    }
    
    // 格式化订单信息
    $order['pay_name'] = $dou->get_one("SELECT name FROM " . $dou->table('plugin') . " WHERE unique_id = '$order[pay_id]'");
    $order['shipping_name'] = $dou->get_one("SELECT name FROM " . $dou->table('plugin') . " WHERE unique_id = '$order[shipping_id]'");
    $order['item_amount_format'] = $dou->price_format($order['item_amount']);
    $order['shipping_fee_format'] = $dou->price_format($order['shipping_fee']);
    $order['order_amount_format'] = $dou->price_format($order['order_amount']);
    $order['order_point_format'] = $order['order_point'] . $_LANG['point_point'];
    $order['email'] = $dou->get_one("SELECT email FROM " . $dou->table('user') . " WHERE user_id = '$order[user_id]'");
    $order['pay_time_limit'] = $dou_order->pay_time_limit($order['add_time'], true); // 付款超时时间
    $order['add_time'] = date("Y-m-d H:i:s", $order['add_time']);
    $order['status_format'] = $order['aftersale_status'] == 2 ? $_LANG['order_aftersale_status_2'] : $_LANG['order_status_' . $order['status']];
    $order['item_list'] = $dou_order->get_order_item($order['order_id']);
    $order['pay_evidence'] = $order['pay_evidence'] ? $dou->dou_file($order['pay_evidence']) : '';
    $order['aftersale_url'] = $dou->param($dou->rewrite_url('aftersale', 'apply') . '&order_sn=' . $order['order_sn']);
    
    // 有开启支付方式的情况才显示付款按钮
    if ($dou->value_exist('plugin', 'plugin_group', 'payment')) {
        $order['cashier_url'] = $dou->param($dou->rewrite_url('order', 'cashier') . '&order_sn=' . $order['order_sn']);
    }

    // 判断是否有安装售后服务模块
    if ($_OPEN['aftersale'])
        $order['if_can_aftersale'] = $dou_aftersale->if_can_aftersale($order['order_id'], $_GLOBAL_USER['user_id']);
 
    // 优惠券模块
    if ($_OPEN['coupon']) {
        include_once (ROOT_PATH . 'include/coupon.class.php');
        $dou_coupon = new Coupon();
     
        $order['coupon'] = $dou_coupon->get_coupon($order['coupon_id']);
        if ($order['coupon'])
            $order['coupon']['amount_format'] = $dou->price_format($order['coupon_amount']);
    }

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'order_view'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'order_view'));
    $smarty->assign('head', $_LANG['order_view']);
    $smarty->assign('order', $order);

    $smarty->display('user.dwt');
}

/**
 * +----------------------------------------------------------
 * 订单删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'order_cancel') {
    // 验证并获取合法的ID
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';

    // 获取订单信息
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'");

    if (!$order || $order['status'] != 0)
        $dou->dou_msg($_LANG['order_cancel_wrong'], $_URL['order_list']);
    
    // 取消订单
    if ($dou->query("UPDATE " . $dou->table('order') . " SET status = '-1' WHERE order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'")) {
        // 库存解锁（stock_lock = 0），并把订单商品状态标记为-1
        $dou->query("UPDATE " . $dou->table('order_item') . " SET order_status = '-1', stock_lock = '0' WHERE order_id = '$order[order_id]'");
     
        // 如果存在订单状态关联，要同步
        if ($order['item_link_status'])
            $dou->query("UPDATE " . $dou->table($order['module']) . " SET order_status = '-1' WHERE order_sn = '$order[order_sn]'");
    }
    
    $dou->dou_header($_URL['order_list']);
}

/**
 * +----------------------------------------------------------
 * 社交软件
 * +----------------------------------------------------------
 */
elseif ($rec == 'sns') {
    $remove = $check->is_unique_id($_REQUEST['remove']) ? trim($_REQUEST['remove']) : '';
    if ($remove) {
        $dou->delete('user_sns', "`group` = '$remove' AND user_id = '$user_id'");
        //$dou->dou_header($_URL['sns']);
    }
 
    // SNS登录
    $link = $check->is_rec($_REQUEST['link']) ? $_REQUEST['link'] : '';
    if ($link) {
        $dou->dou_header(HOME_URL . 'include/plugin/' . $link . '/login.php');
    }
    
    // 赋值给模板息
    $smarty->assign('page_title', $dou->page_title('user', 'user_sns'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_sns'));
    $smarty->assign('head', $_LANG['user_sns']);
    $smarty->assign('plugin_list', $dou_user->connect_plugin_list($_GLOBAL_USER['user_id']));
    
    $smarty->display('user.dwt');
}

/**
 * +----------------------------------------------------------
 * 社交软件账号关联
 * +----------------------------------------------------------
 */
elseif ($rec == 'sns_link') {
    $sns_token = $check->is_number($_REQUEST['sns_token']) ? trim($_REQUEST['sns_token']) : '';
 
    if (!$_SESSION[DOU_ID]['sns'][$sns_token])
        $dou->dou_header($_URL['user']);
 
    // 赋值给模板息
    $smarty->assign('page_title', $dou->page_title('user', 'user_sns'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'user_sns'));
    $smarty->assign('head', $_LANG['user_sns']);
    $smarty->assign('sns', $_SESSION[DOU_ID]['sns'][$sns_token]);
    $smarty->assign('url_register', $dou->param($_URL['register'] . "&sns_token=$sns_token"));
    $smarty->assign('url_login', $dou->param($_URL['login'] . "&sns_token=$sns_token"));
    
    $smarty->display('user_passport.dwt');
}

/**
 * +----------------------------------------------------------
 * 联系人
 * +----------------------------------------------------------
 */
elseif ($rec == 'contact') {
    $smarty->assign('url', $_URL = $dou->dou_act_url($_CUR, $rec, 'add|insert|edit|update|del|set'));
    
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
    
    // 赋值给模板-数据
    $smarty->assign('act', $act);
    $smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));
    
    // 联系人列表
    if ($act == 'default') {
        // 未加入分页条件的SQL语句
        $sql = "SELECT * FROM " . $dou->table('user_contact') . " WHERE user_id = '$user_id' ORDER BY id DESC";

        // 分页
        $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
        $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);

        $sql = $sql . $limit; // 加入分页条件的SQL语句
        $query = $dou->query($sql);
        while ($row = $dou->fetch_array($query)) {
            $contact_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "telphone" => $row['telphone'],
                    "card" => $row['card'],
                    "address" => $row['address'],
                    "address_full" => $dou_user->address_full($row),
                    "default" => $row['default'] ? true : false,
                    "url_default" => $dou->param($_URL['act']['set'] . '&id=' . $row['id']),
                    "url_edit" => $dou->param($_URL['act']['edit'] . '&id=' . $row['id']),
                    "url_del" => $dou->param($_URL['act']['del'] . '&id=' . $row['id'])
            );
        }
        
        // 赋值给模板
        $smarty->assign('page_title', $dou->page_title('user', 'user_contact_manager'));
        $smarty->assign('ur_here', $dou->ur_here('user', 'user_contact_manager'));
        $smarty->assign('head', $_LANG['user_contact_manager']);
        $smarty->assign('contact_list', $contact_list);
     
        $smarty->display('user.dwt');
    }
    
    // 联系人添加
    elseif ($act == 'add') {
        // CSRF防御令牌生成
        $smarty->assign('token', $firewall->get_token('static_user'));
        
        // 赋值给模板
        $smarty->assign('page_title', $dou->page_title('user', 'user_contact_add'));
        $smarty->assign('ur_here', $dou->ur_here('user', 'user_contact_add'));
        $smarty->assign('head', $_LANG['user_contact_add']);
        $smarty->assign('form_action', $_URL['act']['insert']);
     
        $smarty->display('user.dwt');
    }
    
    elseif ($act == 'insert') {
        // 判断是否为空
        $wrong = $check->fn_empty('user_contact', 'name, telphone');
        $wrong = $check->fn_illegal_char('user_contact', 'name, telphone');
     
        if ($_OPEN['area']) {
            $wrong = $check->fn_empty('user_contact', 'province, city, address');
            $wrong = $check->fn_illegal_char('user_contact', 'province, city, district, address');
        }
        
        if ($_CFG['language'] == 'zh_cn' && !$check->is_telphone($_POST['telphone']))
            $wrong['telphone'] = $_LANG['user_contact_telphone'] . $_LANG['is_wrong'];
     
        // 提交方式
        if ($_REQUEST['do'] == 'callback') {
            if ($wrong) {
                foreach ($_POST as $key => $value) {
                    $wrong_json[$key] = $wrong[$key];
                }
                echo json_encode($wrong_json);
            } else {
                echo json_encode('');
            }
            exit;
        } elseif ($_REQUEST['do'] == 'vue') {
            if ($wrong) {
                foreach ($wrong as $value) {
                    $data['wrong'] = $value;
                    die(json_encode($data));
                }
            }
        } else {
            if ($wrong) {
                foreach ($wrong as $key => $value) {
                    $wrong_format[$key] = '<p class="cue">' . $value . '</p>';
                }
                $dou->dou_msg($wrong_format, $_URL['contact']);
            }
        }

        // CSRF防御令牌验证
        $firewall->check_token($_POST['token'], 'static_user');

        // 格式化数据
        $add_time = time();

        // 安全处理用户输入信息
        $_POST = $firewall->dou_foreground($_POST);
     
        if ($_POST['default'])
            $dou->query("UPDATE " . $dou->table('user_contact') . " SET `default` = 0");

        // 提现信息插入
        $sql = "INSERT INTO " . $dou->table('user_contact') . " (id, user_id, name, telphone, card, province, city, district, address, tag, `default`, add_time)" . " VALUES (NULL, '$user_id', '$_POST[name]', '$_POST[telphone]', '$_POST[card]', '$_POST[province]', '$_POST[city]', '$_POST[district]', '$_POST[address]', '$_POST[tag]', '$_POST[default]', '$add_time')";
        $dou->query($sql);

        if ($_REQUEST['do'] == 'vue') {
            // 数据封装
            $data['contact_id'] = $dou->insert_id();
            $data['msg'] = $_LANG['user_contact_add'] . $_LANG['success'];
         
            die(json_encode($data));
        } else {
            $dou->dou_header($_URL['contact']);
        }
    }
    
    // 联系人编辑
    elseif ($act == 'edit') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        // 获取会员信息
        $contact = $dou->get_row('user_contact', '*', "id = '$id' AND user_id = '$user_id'");
        
        // CSRF防御令牌生成
        $smarty->assign('token', $firewall->get_token('static_user'));
        
        // 赋值给模板
        $smarty->assign('page_title', $dou->page_title('user', 'user_contact_edit'));
        $smarty->assign('ur_here', $dou->ur_here('user', 'user_contact_edit'));
        $smarty->assign('head', $_LANG['user_contact_edit']);
        $smarty->assign('form_action', $_URL['act']['update']);
        $smarty->assign('contact', $contact);
     
        $smarty->display('user.dwt');
    }
    
    elseif ($act == 'update') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        // 判断是否为空
        $wrong = $check->fn_empty('user_contact', 'name, telphone');
        $wrong = $check->fn_illegal_char('user_contact', 'name, telphone');
     
        if ($_OPEN['area']) {
            $wrong = $check->fn_empty('user_contact', 'province, city, address');
            $wrong = $check->fn_illegal_char('user_contact', 'province, city, district, address');
        }

        if ($_CFG['language'] == 'zh_cn' && !$check->is_telphone($_POST['telphone']))
            $wrong['telphone'] = $_LANG['user_contact_telphone'] . $_LANG['is_wrong'];
     
        // 提交方式
        if ($_REQUEST['do'] == 'callback') {
            if ($wrong) {
                foreach ($_POST as $key => $value) {
                    $wrong_json[$key] = $wrong[$key];
                }
                echo json_encode($wrong_json);
            } else {
                echo json_encode('');
            }
            exit;
        } elseif ($_REQUEST['do'] == 'vue') {
            if ($wrong) {
                foreach ($wrong as $value) {
                    $data['wrong'] = $value;
                    die(json_encode($data));
                }
            }
        } else {
            if ($wrong) {
                foreach ($wrong as $key => $value) {
                    $wrong_format[$key] = '<p class="cue">' . $value . '</p>';
                }
                $dou->dou_msg($wrong_format, $_URL['contact']);
            }
        }

        // CSRF防御令牌验证
        $firewall->check_token($_POST['token'], 'static_user');

        // 格式化数据
        $add_time = time();

        // 安全处理用户输入信息
        $_POST = $firewall->dou_foreground($_POST);
        
        $sql = "UPDATE " . $dou->table('user_contact') . " SET name = '$_POST[name]', telphone = '$_POST[telphone]', card = '$_POST[card]', province = '$_POST[province]', city = '$_POST[city]', district = '$_POST[district]', address = '$_POST[address]', tag = '$_POST[tag]' WHERE id = '$id' AND user_id = '$user_id'";
        $dou->query($sql);

        if ($_REQUEST['do'] == 'vue') {
            // 数据封装
            $data['contact_id'] = $id;
            $data['msg'] = $_LANG['user_contact_edit'] . $_LANG['success'];
         
            die(json_encode($data));
        } else {
            $dou->dou_header($_URL['contact']);
        }
    }
    
    // 设为默认
    elseif ($act == 'del') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $dou->delete('user_contact', "id = '$id'", $_URL['contact']);
    }
    
    // 设为默认
    elseif ($act == 'set') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $dou->query("UPDATE " . $dou->table('user_contact') . " SET `default` = 0");
        $dou->query("UPDATE " . $dou->table('user_contact') . " SET `default` = 1 WHERE id = '$id'");

        $dou->dou_header($_URL['contact']);
    }

    // 联系人列表
    elseif ($act == 'list') {
        // 获取请求
        $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : $dou->get_value('user_contact', 'id', "user_id = '$user_id' ORDER BY `default` DESC, id DESC");

        $data['contact_list'] = $dou_user->contact_list($user_id, $contact_id);

        echo json_encode($data);
    }

    // 联系人信息
    elseif ($act == 'info') {
        // 获取请求
        $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : $dou->get_value('user_contact', 'id', "user_id = '$user_id' ORDER BY `default` DESC, id DESC");

        $contact = $dou->get_row('user_contact', '*', "id = '$contact_id' AND user_id = '$user_id'");
        $contact['address_full'] = $dou_user->address_full($contact);
     
        $data['contact'] = $contact;

        echo json_encode($data);
    }
    
}

/**
 * +----------------------------------------------------------
 * 地区选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'area') {
    include_once (ROOT_PATH . 'include/area.class.php');
    $dou_area = new Area();
    
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : 'province';
 
    if ($type == 'init') {
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        $data['contact'] = $dou_area->get_contact($id);
    } else {
        $parent = !$check->is_illegal_char($_REQUEST['parent']) ? $_REQUEST['parent'] : '';
        $current = !$check->is_illegal_char($_REQUEST['current']) ? $_REQUEST['current'] : '';

        if ($type == 'province') {
            $parent_id = 0;
        } else {
            $parent_id = $dou->get_value('area', 'id', "name = '$parent'");
        }

        $data['area_list'] = $dou_area->get_area_list($parent_id, $current);
    }

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 验证并获取合法的REQUEST
    $module = $check->is_letter($_REQUEST['module']) ? $_REQUEST['module'] : '';

    $folder = $check->is_letter($_REQUEST['folder']) ? $_REQUEST['folder'] : 'no';
 
    if ($folder == 'yes')
        $_folder = date('Ymd') . '/';

    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/' . $module . '/' . $_folder); // 实例化类文件(文件上传路径，结尾加斜杠)

    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : '';
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : '';
    $target = $check->is_basic_string($_REQUEST['target']) ? $_REQUEST['target'] : '';
    $img_width = $check->is_number($_REQUEST['img_width']) ? $_REQUEST['img_width'] : $_CFG['img_width'];
    $field = $target . '_file';

    // 文件上传盒子
    if ($type == 'content') {
        // 重组多图数组
        $total = count($_FILES[$field]['name']);
        for ($i = 0; $i < $total; $i++) {
            $_NEW_FILES[$field . $i] = array (
                    "name" => $_FILES[$field]['name'][$i],
                    "type" => $_FILES[$field]['type'][$i],
                    "tmp_name" => $_FILES[$field]['tmp_name'][$i],
                    "error" => $_FILES[$field]['error'][$i],
                    "size" => $_FILES[$field]['size'][$i]
            );
        }
     
        // 数组
        foreach ($_NEW_FILES as $field => $value) {
            $custom_filename = $item_id . '_' . $target . '_' . $dou->create_rand_string('number', 6, time());
            $image = $file->box($module, $item_id, $field, $type, $custom_filename, '', '', $img_width, $_CFG['watermark'], 'id', $_NEW_FILES);

            $html .= '<img src="' . $dou->dou_file($image) . '" data-file="' . $image . '" /><br/><br/>';
        }
    } else {
        // 最多只能上传三张图片
        $file_number = $dou->get_one("SELECT COUNT(*) FROM " .$dou->table('file') . " WHERE module = '$module' AND item_id = '$item_id' AND type = '$type'");
        if ($file_number < 3) {
             $custom_filename = $item_id . '_' . $target . '_' . $dou->create_rand_string('number', 6, time());
            $image = $file->box($module, $item_id, $field, $type, $custom_filename, '', '', $img_width, $_CFG['watermark']);
        }
        
        $html = $dou->get_file_list($module, $item_id, $type);
    }
    
    echo $html;
}

/**
 * +----------------------------------------------------------
 * 文件删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'filedel') {
    // 验证并获取合法的REQUEST
    $number = preg_match("/^[a-z0-9.]+$/", $_REQUEST['number']) ? $_REQUEST['number'] : '';
    $file_info = $dou->get_row('file', 'module, item_id, type', "number = '$number'");
    
    // 删除文件
    $dou->del_file($number);
 
    // 显示已经上传的文件列表
    $html = $dou->get_file_list($file_info['module'], $file_info['item_id'], $file_info['type']);
    
    echo $html;
}

/**
 * +----------------------------------------------------------
 * 推荐二维码
 * +----------------------------------------------------------
 */
elseif ($rec == 'promotion_qrcode') {
    $code = $dou->param($_URL['register'] . '&user_sn=' . $_GLOBAL_USER['user_sn']);
    
    // 生成二维码图片 
    include_once (ROOT_PATH . 'include/phpqrcode.class.php');
    $errorCorrectionLevel = 'H';//容错级别 
    $matrixPointSize = 10;//生成图片大小
    
    QRcode::png($code, false, 'L', 10, 2);

    return $code;
}

?>